Subject: Re: [PATCH] pull: respect submodule update configuration

From: Junio C Hamano <[email-masked]>
Date: Mon, 21 Aug 2017 15:52:09 -0700

Brandon Williams <[email-masked]> writes:

>> > I tried to make it work here:
>> > https://public-inbox.org/git/[email-masked]/
>> 
>> (A) you need to set expect there as well, to have sub{2,4,5} be expected
>> there as well.
>> 
>> (B) That may hint at another (UX) bug.
>> 
>> The test case there uses "git submodule update --init".
>> The init flag will set all submodules to active.
>> 
>> Maybe you want
>> 
>>     git config submodule.active ":(exclude)sub0"
>>     git config --add submodule.active ":(exclude)sub2"
>>     git config --add submodule.active "."
>>     # Read: anything except sub0 and sub2 are interesting
>> 
>>     git submodule update
>>     # no init flag, needed even for new submodules IIUC

Sounds like a good solution.  I do think what Stefan said about
"reset --hard --recurse-submodules" makes tons of sense, and we
should do a hard reset in submodules as long as they are marked
as active, regardless of what the .update option says.  I have
not thought deeply enough about other operations like "pull" in
his message to be able to comment, though.

Thanks.